Ipelib: ipe::Platform Class Reference

Ipelib

Public Types | Static Public Member Functions | List of all members
ipe::Platform Class Reference
Ipe Base

`#include <ipebase.h>`

## Public Types
using | DebugHandler = void(*)(const char *)

## Static Public Member Functions
static FILE * | fopen (const char *fname, const char *mode)
static String | ipeDrive ()
static int | libVersion ()
static void | initLib (int version)
static void | setDebug (bool debug)
static String | currentDirectory ()
static String | latexDirectory ()
static String | latexPath ()
static bool | fileExists (String fname)
static bool | listDirectory (String path, std::vector< String > &files)
static String | realPath (String fname)
static String | readFile (String fname)
static int | runLatex (String dir, LatexType engine, String docname) noexcept
static double | toDouble (String s)
static int | toNumber (String s, int &iValue, double &dValue)

## Detailed Description

Platform dependent methods.

## Member Typedef Documentation

## ◆ DebugHandler

using ipe::Platform::DebugHandler = void (*)(const char *)

## Member Function Documentation

## ◆ fopen()

static FILE* ipe::Platform::fopen | ( | const char * | fname,
|  | const char * | mode
| ) |  |
| inlinestatic

Referenced by ipe::Document::exportPages(), ipe::Document::exportView(), ipe::Document::load(), readFile(), ipe::Bitmap::readJpeg(), ipe::Bitmap::readPNG(), ipe::Document::runLatex(), runLatex(), ipe::Document::save(), ipe::Bitmap::savePixels(), and ipe::Thumbnail::saveRender().

## ◆ ipeDrive()

String Platform::ipeDrive | ( |  | ) |
| static

Returns drive on which Ipe executable exists.

On Linux and OSX, returns empty string.

References ipe::IPESEP, ipe::String::left(), ipe::String::rfind(), ipe::size(), and ipe::String::size().

Referenced by latexDirectory(), and latexPath().

## ◆ libVersion()

int Platform::libVersion | ( |  | ) |
| static

Return the Ipelib version.

This is available as a function so that one can verify what version of Ipelib one has actually linked with (as opposed to the header files used during compilation).

References ipe::Repository::cleanup(), ipe::String::data(), ipe::String::empty(), fileExists(), ipe::String::getLine(), ipe::IPELIB_VERSION, readFile(), ipe::String::size(), and ipe::String::z().

## ◆ initLib()

void Platform::initLib | ( | int | version | ) |
| static

Initialize Ipelib.

This method must be called before Ipelib is used.

It creates a LC_NUMERIC locale set to 'C', which is necessary for correct loading and saving of Ipe objects. The method also checks that the correct version of Ipelib is loaded, and aborts with an error message if the version is not correct. Also enables ipeDebug messages if environment variable IPEDEBUG is defined. (You can override this using setDebug).

References ipe::IPELIB_VERSION.

## ◆ setDebug()

void Platform::setDebug | ( | bool | debug | ) |
| static

Enable or disable display of ipeDebug messages.

## ◆ currentDirectory()

String Platform::currentDirectory | ( |  | ) |
| static

Returns current working directory.

Returns empty string if something fails.

## ◆ latexDirectory()

String Platform::latexDirectory | ( |  | ) |
| static

Returns directory for running Latex.

The directory is created if it does not exist. Returns an empty string if the directory cannot be found or cannot be created. The directory returned ends in the path separator.

References fileExists(), ipeDrive(), ipe::String::left(), ipe::String::right(), ipe::String::size(), ipe::String::substr(), and ipe::String::z().

Referenced by ipe::Document::runLatex().

## ◆ latexPath()

String Platform::latexPath | ( |  | ) |
| static

Return path for the directory containing pdflatex and xelatex.

If empty means look on PATH.

References ipeDrive(), ipe::String::left(), and ipe::String::substr().

Referenced by runLatex().

## ◆ fileExists()

bool Platform::fileExists | ( | String | fname | ) |
| static

Determine whether file exists.

References ipe::String::data(), and ipe::String::z().

Referenced by latexDirectory(), and libVersion().

## ◆ listDirectory()

bool Platform::listDirectory | ( | String | path,
|  | std::vector< String > & | files
| ) |  |
| static

List all files in directory.

Return true if successful, false on error.

References ipe::String::data(), and ipe::String::z().

## ◆ realPath()

String Platform::realPath | ( | String | fname | ) |
| static

Convert relative filename to absolute.

This also works when the filename does not exist, or at least it tries.

References ipe::String::data(), ipe::String::left(), and ipe::String::z().

Referenced by runLatex().

## ◆ readFile()

String Platform::readFile | ( | String | fname | ) |
| static

Read entire file into string.

Returns an empty string if file cannot be found or read. There is no way to distinguish an empty file from this.

References ipe::String::append(), fopen(), and ipe::String::z().

Referenced by libVersion(), ipe::Bitmap::readJpeg(), ipe::Document::runLatex(), and runLatex().

## ◆ runLatex()

int Platform::runLatex | ( | String | dir,
|  | LatexType | engine,
|  | String | docname
| ) |  |
| staticnoexcept

Runs latex on file ipetemp.tex in given directory.

directory of docname is added to TEXINPUTS if its non-empty.

References ipe::String::empty(), fopen(), ipe::IPESEP, latexPath(), ipe::String::left(), ipe::Luatex, readFile(), realPath(), ipe::size(), ipe::String::String(), ipe::String::substr(), ipe::Xetex, and ipe::String::z().

Referenced by ipe::Document::runLatex().

## ◆ toDouble()

double Platform::toDouble | ( | String | s | ) |
| static

References ipe::String::z().

Referenced by ipe::Lex::getDouble(), ipe::PdfParser::getObject(), and ipe::PdfParser::getToken().

## ◆ toNumber()

int Platform::toNumber | ( | String | s,
|  | int & | iValue,
|  | double & | dValue
| ) |  |
| static

References ipe::String::z().

The documentation for this class was generated from the following files:

- ipebase.h
- ipeplatform.cpp